
(function(l, r) { if (l.getElementById('livereloadscript')) return; r = l.createElement('script'); r.async = 1; r.src = '//' + (window.location.host || 'localhost').split(':')[0] + ':35729/livereload.js?snipver=1'; r.id = 'livereloadscript'; l.getElementsByTagName('head')[0].appendChild(r) })(window.document);
(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('axios'), require('datapipe-js/utils')) :
    typeof define === 'function' && define.amd ? define(['exports', 'axios', 'datapipe-js/utils'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global['sql-data-api'] = {}, global.axios, global.utils));
}(this, (function (exports, axios, utils) { 'use strict';

    function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

    var axios__default = /*#__PURE__*/_interopDefaultLegacy(axios);

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function setBaseUrl(baseUrl) {
        SqlDataApi.BaseUrl = baseUrl;
    }
    function setBearerToken(bearerToken) {
        SqlDataApi.BearerToken = bearerToken;
    }
    function setUserAccessToken(userAccessToken) {
        SqlDataApi.UserAccessToken = userAccessToken;
    }
    function authenticate(username, password) {
        return __awaiter(this, void 0, void 0, function () {
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = SqlDataApi;
                        return [4 /*yield*/, httpRequest('POST', SqlDataApi.BaseUrl + "/api/security/authenticate", { username: username, password: password })];
                    case 1:
                        _a.BearerToken = (_b.sent()).token;
                        return [2 /*return*/, true];
                }
            });
        });
    }
    function sqlDataApi(connectionName, config) {
        var cfg = {
            userAccessToken: (config === null || config === void 0 ? void 0 : config.userAccessToken) || SqlDataApi.UserAccessToken,
            bearerToken: (config === null || config === void 0 ? void 0 : config.bearerToken) || SqlDataApi.BearerToken
        };
        return new SqlDataApi((config === null || config === void 0 ? void 0 : config.baseUrl) || SqlDataApi.BaseUrl, connectionName, cfg);
    }
    var SqlDataApi = /** @class */ (function () {
        function SqlDataApi(baseUrl, connectionName, config) {
            this.baseUrl = baseUrl;
            this.connectionName = connectionName;
            this.userAccessToken = config === null || config === void 0 ? void 0 : config.userAccessToken;
            this.bearerToken = config === null || config === void 0 ? void 0 : config.bearerToken;
        }
        SqlDataApi.prototype.query = function (tableOrViewName, fieldsOrQuery, queryInfoSettings) {
            return __awaiter(this, void 0, void 0, function () {
                function extractNameAndAlias(tableOrViewWithAlias) {
                    tableOrViewWithAlias = tableOrViewWithAlias.trim();
                    return {
                        alias: tableOrViewWithAlias.indexOf(' ') > 0 ?
                            tableOrViewWithAlias.substring(tableOrViewWithAlias.lastIndexOf(' ')).trim()
                            : undefined,
                        name: tableOrViewWithAlias.indexOf(' ') > 0 ?
                            tableOrViewWithAlias.substring(0, tableOrViewWithAlias.indexOf(' ')).trim()
                            : tableOrViewWithAlias.trim()
                    };
                }
                function join(joins, joinType, tableOrViewWithAlias, joinCondition) {
                    var nameAlias = extractNameAndAlias(tableOrViewWithAlias);
                    joins.push({
                        joinCondition: joinCondition,
                        joinType: joinType,
                        tableAlias: nameAlias.alias,
                        tableName: nameAlias.name
                    });
                    return joins;
                }
                var queryInfo, fields, mainTable, tablesJoin, _i, _a, j, filterParams, request, url, headers, response;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            queryInfo = queryInfoSettings
                                || typeof fieldsOrQuery === 'object' ? fieldsOrQuery :  {};
                            fields = (typeof fieldsOrQuery === 'string' && fieldsOrQuery && fieldsOrQuery !== '*') ? fieldsOrQuery
                                : queryInfo === null || queryInfo === void 0 ? void 0 : queryInfo.fields;
                            mainTable = extractNameAndAlias(tableOrViewName);
                            tablesJoin = [];
                            if (queryInfo.joins && queryInfo.joins.length) {
                                for (_i = 0, _a = queryInfo.joins; _i < _a.length; _i++) {
                                    j = _a[_i];
                                    join(tablesJoin, j[0], j[1], j[2]);
                                }
                            }
                            filterParams = queryInfo.filterParams ? this.toPrimitive(queryInfo.filterParams) : undefined;
                            request = {
                                select: fields,
                                filterString: queryInfo.filter,
                                filterParameters: filterParams,
                                skip: queryInfo.skip,
                                top: queryInfo.top,
                                orderBy: queryInfo.orderBy,
                                mainTableAlias: mainTable.alias,
                                tablesJoin: tablesJoin
                            };
                            url = this.baseUrl + "/sql-data-api/" + this.connectionName + "/query/" + mainTable.name;
                            headers = {};
                            if (this.bearerToken) {
                                headers["Authorization"] = "Bearer " + this.bearerToken;
                            }
                            else if (this.userAccessToken) {
                                url += "?$accessToken=" + this.userAccessToken;
                            }
                            return [4 /*yield*/, httpRequest('POST', url, request, headers)];
                        case 1:
                            response = _b.sent();
                            return [2 /*return*/, utils.fromTable(response.table)];
                    }
                });
            });
        };
        SqlDataApi.prototype.save = function (tableName, items, itemsToDeleteOrSaveOptions, saveOptions) {
            return __awaiter(this, void 0, void 0, function () {
                var itemsToDelete, maxTableSize, maxRowsCount, primaryKeys, url, headers, table, status, allRows, body, currentIndex, currentSize, row, singleStatus;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            itemsToDelete = undefined;
                            if (!saveOptions && itemsToDeleteOrSaveOptions && !Array.isArray(itemsToDeleteOrSaveOptions)) {
                                saveOptions = itemsToDeleteOrSaveOptions;
                            }
                            else if (itemsToDeleteOrSaveOptions && Array.isArray(itemsToDeleteOrSaveOptions)) {
                                itemsToDelete = itemsToDeleteOrSaveOptions;
                            }
                            maxTableSize = 1500000;
                            maxRowsCount = (saveOptions === null || saveOptions === void 0 ? void 0 : saveOptions.chunkSize) || 10000;
                            primaryKeys = (saveOptions === null || saveOptions === void 0 ? void 0 : saveOptions.primaryKeys) || undefined;
                            url = this.baseUrl + "/sql-data-api/" + this.connectionName + "/save/" + tableName;
                            headers = {};
                            if (this.bearerToken) {
                                headers["Authorization"] = "Bearer " + this.bearerToken;
                            }
                            else if (this.userAccessToken) {
                                url += "?$accessToken=" + this.userAccessToken;
                            }
                            table = utils.toTable(items);
                            status = {
                                inserted: 0,
                                updated: 0,
                                deleted: 0
                            };
                            allRows = table.rows;
                            body = {
                                tableData: {
                                    fieldNames: table.fieldNames,
                                    rows: []
                                },
                                itemsToDelete: itemsToDelete,
                                primaryKeys: primaryKeys
                            };
                            currentIndex = -1;
                            currentSize = 0;
                            _a.label = 1;
                        case 1:
                            if (!(++currentIndex < allRows.length)) return [3 /*break*/, 4];
                            row = allRows[currentIndex];
                            body.tableData.rows.push(row);
                            currentSize += JSON.stringify(allRows[currentIndex]).length;
                            if (!((currentIndex + 1) >= allRows.length || body.tableData.rows.length >= maxRowsCount || currentSize > maxTableSize)) return [3 /*break*/, 3];
                            return [4 /*yield*/, httpRequest('POST', url, body, headers)];
                        case 2:
                            singleStatus = (_a.sent());
                            status.inserted += singleStatus.inserted;
                            status.updated += singleStatus.updated;
                            status.deleted += singleStatus.deleted;
                            currentSize = 0;
                            body.tableData.rows = [];
                            _a.label = 3;
                        case 3: return [3 /*break*/, 1];
                        case 4: return [2 /*return*/, status];
                    }
                });
            });
        };
        SqlDataApi.prototype.sqlExecute = function (sql, params) {
            var _a;
            return __awaiter(this, void 0, void 0, function () {
                var dto, url, headers, result;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            sql = (sql === null || sql === void 0 ? void 0 : sql.trim()) || '';
                            if (!sql.length) {
                                throw new Error('sql text is not provided');
                            }
                            if (!((_a = this.connectionName) === null || _a === void 0 ? void 0 : _a.length)) {
                                throw new Error('connection is not provided');
                            }
                            if (params) {
                                params = this.toPrimitive(params);
                            }
                            dto = {
                                commandType: sql.indexOf(' ') > 0 ? 'Text' : 'StoredProcedure',
                                sql: sql, params: params
                            };
                            url = this.baseUrl + "/sql-data-api/" + this.connectionName + "/execute";
                            headers = {};
                            if (this.bearerToken) {
                                headers["Authorization"] = "Bearer " + this.bearerToken;
                            }
                            else if (this.userAccessToken) {
                                url += "?$accessToken=" + this.userAccessToken;
                            }
                            return [4 /*yield*/, httpRequest('POST', url, dto, headers)];
                        case 1:
                            result = _b.sent();
                            return [2 /*return*/, (result === null || result === void 0 ? void 0 : result.table) ? utils.fromTable(result.table) : result];
                    }
                });
            });
        };
        SqlDataApi.prototype.toPrimitive = function (obj) {
            var scalarToPrimitive = function (val) {
                if (Array.isArray(val)) {
                    return val.map(function (v) { return scalarToPrimitive(v); });
                }
                return val instanceof Date ? utils.dateToString(val) : val;
            };
            var result = {};
            Object.keys(obj)
                .forEach(function (k) { return result[k] = scalarToPrimitive(obj[k]); });
            return result;
        };
        return SqlDataApi;
    }());
    function httpRequest(method, url, body, headers) {
        var requestConfig = {
            method: method, url: url,
            headers: __assign({ 'Content-Type': 'application/json' }, (headers || {})),
            data: JSON.stringify(body || {})
        };
        return axios__default['default'].request(requestConfig)
            .then(function (r) { return r.data; }, function (e) {
            // making an error more informative.
            // this was a reason why we switched to axios, as it gives us a real exception details,
            // beyond a statusText
            var response = e.response || {};
            var err = Error((response.data || {}).message || response.data || response.statusText || 'Http Connection Error');
            err.status = response.status;
            err.statusText = response.statusText;
            throw err;
        });
    }
    var JoinType;
    (function (JoinType) {
        JoinType["InnerJoin"] = "InnerJoin";
        JoinType["LeftJoin"] = "LeftJoin";
        JoinType["RightJoin"] = "RightJoin";
        JoinType["FullJoin"] = "FullJoin";
    })(JoinType || (JoinType = {}));

    exports.SqlDataApi = SqlDataApi;
    exports.authenticate = authenticate;
    exports.httpRequest = httpRequest;
    exports.setBaseUrl = setBaseUrl;
    exports.setBearerToken = setBearerToken;
    exports.setUserAccessToken = setUserAccessToken;
    exports.sqlDataApi = sqlDataApi;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=sql-data-api.js.map
